# CS631-Project: Automatic Index creation in postgres.

***Authors** @meet.doshi @gaurangathavale @jiteshg*

---

#### For checking patch updates 
```
Just look at the following files
execMain.c
nodeSeqScan.c
worker_spi/worker_spi.c
Makefile

Look for following tags
/* CS631 start */
/* CS631 end */
```

###File Structure:

```
<22m0742_22m0752>
├── execMain.c ~ User queries without where clause dont reach node sequential scan level. So they have to be stored at execMain level. Currently we are only saving insert and delete queries.
├── nodeSeqScan.c ~ Operates at table level. Here we are keeping track of all select queries with and without where clause.
├── worker_spi/ ~ This module should be registered in contrib folder and requires updates in the make file in same folder.
│   ├── worker_spi.c ~ This is the daemon process which runs every 20 seconds. It alternates with a toggle where first time it fetches info and decides which index to create. On the next round it executes the query and creates the index.
└── readme.md

```


###Tasks:

1. Storing logs of incoming user queries for later use on making a decision whether to create an index or not.
2. Creating a daemon process like a cron job for the database which runs regularly to check whether indexes need to be created or not.
3. Building up logic for the daemon process to decided whether indexes need to be created or deleted.

###Cautions:
1. Installing worker module correctly and updating makefiles.
2. Accessing uninitialized or modifying static memory.
3. Recursive loops inside code.
4. Codebase changes due to changes in postgres versions. So be sure to check if the data structures and libraries are matching. 
5. Mutliple where clauses and subqueries.
6. Current postgres version 13.7 `Different from the git version`